/*
 *  Exported prototypes, they are needed by rte
 *
 *  Copyright (C) 2000 Iaki G.E.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef __MAIN_H__
#define __MAIN_H__

/* fixme: leave only neccessary prototypes */

extern double		video_stop_time;
extern double		audio_stop_time;

extern pthread_t	audio_thread_id;
extern fifo *		audio_cap_fifo;
extern int		stereo;

extern pthread_t	video_thread_id;
extern fifo *		video_cap_fifo;
extern void		(* video_start)(void);

extern pthread_t        output_thread_id;

extern pthread_t	tk_main_id;
extern void *		tk_main(void *);

extern int		mux_mode;
extern int		psycho_loops;
extern int		audio_num_frames;
extern int		video_num_frames;

extern void options(int ac, char **av);

extern void preview_init(void);

extern void video_init(void);

extern volatile int program_shutdown;

extern pthread_t video_emulation_thread_id;
extern pthread_t audio_emulation_thread_id;
extern pthread_mutex_t video_device_mutex;
extern pthread_mutex_t audio_device_mutex;

extern fifo *		ye_olde_audio_cap_fifo;

extern unsigned char *	(* ye_olde_wait_frame)(double *, int *);
extern void		(* ye_olde_frame_done)(int);

#endif // MAIN.H
