/*
 *  MPEG-1 Real Time Encoder
 *
 *  Copyright (C) 1999-2000 Michael H. Schimek
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* $Id: decode.c,v 1.2 2000/11/30 09:36:38 mschimek Exp $ */

/* OBSOLETE */

#include "../common/mmx.h"
#include "../common/math.h"
#include "vbi.h"

unsigned char
bit_reverse[256] __attribute__ ((aligned(CACHE_LINE))) = {
	0x00, 0x80, 0x40, 0xc0, 0x20, 0xa0, 0x60, 0xe0,	0x10, 0x90, 0x50, 0xd0, 0x30, 0xb0, 0x70, 0xf0,
	0x08, 0x88, 0x48, 0xc8, 0x28, 0xa8, 0x68, 0xe8,	0x18, 0x98, 0x58, 0xd8, 0x38, 0xb8, 0x78, 0xf8,
	0x04, 0x84, 0x44, 0xc4, 0x24, 0xa4, 0x64, 0xe4,	0x14, 0x94, 0x54, 0xd4, 0x34, 0xb4, 0x74, 0xf4,
	0x0c, 0x8c, 0x4c, 0xcc, 0x2c, 0xac, 0x6c, 0xec,	0x1c, 0x9c, 0x5c, 0xdc, 0x3c, 0xbc, 0x7c, 0xfc,
	0x02, 0x82, 0x42, 0xc2, 0x22, 0xa2, 0x62, 0xe2,	0x12, 0x92, 0x52, 0xd2, 0x32, 0xb2, 0x72, 0xf2,
	0x0a, 0x8a, 0x4a, 0xca, 0x2a, 0xaa, 0x6a, 0xea,	0x1a, 0x9a, 0x5a, 0xda, 0x3a, 0xba, 0x7a, 0xfa,
	0x06, 0x86, 0x46, 0xc6, 0x26, 0xa6, 0x66, 0xe6,	0x16, 0x96, 0x56, 0xd6, 0x36, 0xb6, 0x76, 0xf6,
	0x0e, 0x8e, 0x4e, 0xce, 0x2e, 0xae, 0x6e, 0xee,	0x1e, 0x9e, 0x5e, 0xde, 0x3e, 0xbe, 0x7e, 0xfe,
	0x01, 0x81, 0x41, 0xc1, 0x21, 0xa1, 0x61, 0xe1,	0x11, 0x91, 0x51, 0xd1, 0x31, 0xb1, 0x71, 0xf1,
	0x09, 0x89, 0x49, 0xc9, 0x29, 0xa9, 0x69, 0xe9,	0x19, 0x99, 0x59, 0xd9, 0x39, 0xb9, 0x79, 0xf9,
	0x05, 0x85, 0x45, 0xc5, 0x25, 0xa5, 0x65, 0xe5,	0x15, 0x95, 0x55, 0xd5, 0x35, 0xb5, 0x75, 0xf5,
	0x0d, 0x8d, 0x4d, 0xcd, 0x2d, 0xad, 0x6d, 0xed,	0x1d, 0x9d, 0x5d, 0xdd, 0x3d, 0xbd, 0x7d, 0xfd,
	0x03, 0x83, 0x43, 0xc3, 0x23, 0xa3, 0x63, 0xe3,	0x13, 0x93, 0x53, 0xd3, 0x33, 0xb3, 0x73, 0xf3,
	0x0b, 0x8b, 0x4b, 0xcb, 0x2b, 0xab, 0x6b, 0xeb,	0x1b, 0x9b, 0x5b, 0xdb, 0x3b, 0xbb, 0x7b, 0xfb,
	0x07, 0x87, 0x47, 0xc7, 0x27, 0xa7, 0x67, 0xe7,	0x17, 0x97, 0x57, 0xd7, 0x37, 0xb7, 0x77, 0xf7,
	0x0f, 0x8f, 0x4f, 0xcf, 0x2f, 0xaf, 0x6f, 0xef,	0x1f, 0x9f, 0x5f, 0xdf, 0x3f, 0xbf, 0x7f, 0xff
};

#if 0

// use P flag on x86

unsigned char parity[256];

#define odd_parity(n)	((int)(parity[(int)((unsigned char)(n))]) < 0)
#define even_parity(n)	((int)(parity[(int)((unsigned char)(n))]) >= 0)
#define make_odd(n)	(parity[(int)(((unsigned char)(n)) | 0x80)])
#define make_even(n)	(parity[(int)(((unsigned char)(n)) & 0x7F)])

void init_parity(void) __attribute__ ((constructor));

void
init_parity(void)
{
	int i, n;

	for (i = 0; i < 256; i++) {
		n  = i;
		n ^= (n >> 4);
		n ^= (n >> 2);
		n ^= (n >> 1);
		n &= 1;

		parity[i] = (n << 7) | (i & 0x7F);
	}
}

#endif

/*
 *  ETS 300 706 8.2 Hamming 8/4
 */
char
hamming84[256] __attribute__ ((aligned(CACHE_LINE))) =
{
	0x01,   -1, 0x01, 0x01,   -1, 0x00, 0x01,   -1,	  -1, 0x02, 0x01,   -1, 0x0a,   -1,   -1, 0x07,
	  -1, 0x00, 0x01,   -1, 0x00, 0x00,   -1, 0x00,	0x06,   -1,   -1, 0x0b,   -1, 0x00, 0x03,   -1,
	  -1, 0x0c, 0x01,   -1, 0x04,   -1,   -1, 0x07,	0x06,   -1,   -1, 0x07,   -1, 0x07, 0x07, 0x07,
	0x06,   -1,   -1, 0x05,   -1, 0x00, 0x0d,   -1,	0x06, 0x06, 0x06,   -1, 0x06,   -1,   -1, 0x07,
	  -1, 0x02, 0x01,   -1, 0x04,   -1,   -1, 0x09,	0x02, 0x02,   -1, 0x02,   -1, 0x02, 0x03,   -1,
	0x08,   -1,   -1, 0x05,   -1, 0x00, 0x03,   -1,	  -1, 0x02, 0x03,   -1, 0x03,   -1, 0x03, 0x03,
	0x04,   -1,   -1, 0x05, 0x04, 0x04, 0x04,   -1,	  -1, 0x02, 0x0f,   -1, 0x04,   -1,   -1, 0x07,
	  -1, 0x05, 0x05, 0x05, 0x04,   -1,   -1, 0x05,	0x06,   -1,   -1, 0x05,   -1, 0x0e, 0x03,   -1,
	  -1, 0x0c, 0x01,   -1, 0x0a,   -1,   -1, 0x09,	0x0a,   -1,   -1, 0x0b, 0x0a, 0x0a, 0x0a,   -1,
	0x08,   -1,   -1, 0x0b,   -1, 0x00, 0x0d,   -1,	  -1, 0x0b, 0x0b, 0x0b, 0x0a,   -1,   -1, 0x0b,
	0x0c, 0x0c,   -1, 0x0c,   -1, 0x0c, 0x0d,   -1,	  -1, 0x0c, 0x0f,   -1, 0x0a,   -1,   -1, 0x07,
	  -1, 0x0c, 0x0d,   -1, 0x0d,   -1, 0x0d, 0x0d,	0x06,   -1,   -1, 0x0b,   -1, 0x0e, 0x0d,   -1,
	0x08,   -1,   -1, 0x09,   -1, 0x09, 0x09, 0x09,	  -1, 0x02, 0x0f,   -1, 0x0a,   -1,   -1, 0x09,
	0x08, 0x08, 0x08,   -1, 0x08,   -1,   -1, 0x09,	0x08,   -1,   -1, 0x0b,   -1, 0x0e, 0x03,   -1,
	  -1, 0x0c, 0x0f,   -1, 0x04,   -1,   -1, 0x09,	0x0f,   -1, 0x0f, 0x0f,   -1, 0x0e, 0x0f,   -1,
	0x08,   -1,   -1, 0x05,   -1, 0x0e, 0x0d,   -1,	  -1, 0x0e, 0x0f,   -1, 0x0e, 0x0e,   -1, 0x0e
};

/*
 *  Bi-phase modulation (VPS) :-P
 */
char
biphase[256] __attribute__ ((aligned(CACHE_LINE))) =
{
	  -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
	  -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
	  -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
	  -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
	  -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
	  -1,   -1,   -1,   -1,   -1, 0x0f, 0x07,   -1,   -1, 0x0b, 0x03,   -1,   -1,   -1,   -1,   -1,
	  -1,   -1,   -1,   -1,   -1, 0x0d, 0x05,   -1,   -1, 0x09, 0x01,   -1,   -1,   -1,   -1,   -1,
	  -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
	  -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
	  -1,   -1,   -1,   -1,   -1, 0x0e, 0x06,   -1,   -1, 0x0a, 0x02,   -1,   -1,   -1,   -1,   -1,
	  -1,   -1,   -1,   -1,   -1, 0x0c, 0x04,   -1,   -1, 0x08, 0x00,   -1,   -1,   -1,   -1,   -1,
	  -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
	  -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
	  -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
	  -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
	  -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
};

void
init_decoder(struct decode_rec *d,
	int raw_bytes, int sampling_rate, int bit_rate,
	unsigned int frc, unsigned int frc_mask, int payload)
{
	unsigned int
	int_reverse(unsigned int n)
	{
		return (bit_reverse[n & 0xFF] << 24)
		       + (bit_reverse[(n >> 8) & 0xFF] << 16)
		       + (bit_reverse[(n >> 16) & 0xFF] << 8)
		       + bit_reverse[(n >> 24) & 0xFF];
	};

	d->frc_mask		= int_reverse(frc_mask);
	d->framing_code 	= int_reverse(frc) & d->frc_mask;
	d->frc_bytes		= raw_bytes - sampling_rate * (8 * payload + 2) / bit_rate;
	d->step8		= sampling_rate * 256.0 / bit_rate;
	d->bit_rate		= bit_rate;
	d->oversampling_rate	= sampling_rate * 4;
	d->payload		= payload;
	d->thresh		= 105 << 10;
}

bool
decode_nrz(struct decode_rec *d, unsigned char *raw, unsigned char *buf)
{
	int i, j, k;
        int tr, b, b1 = 0, cl = 0;
	unsigned int c = 0, t, s;

	for (i = d->frc_bytes; i > 0; raw++, i--) {
		tr = d->thresh >> 10;
		d->thresh += ((int) raw[0] - tr) * abs(raw[1] - raw[0]);
		t = raw[0] * 4;

		for (j = 4; j > 0; j--) {
			s = (t + 2) >> 2;
			b = (s >= tr);

    			if (b ^ b1) {
				cl = d->oversampling_rate >> 1;
			} else {
				cl += d->bit_rate;

				if (cl >= d->oversampling_rate) {
					cl -= d->oversampling_rate;

					c = c * 2 + b;

					if ((c & d->frc_mask) == d->framing_code) {
						i = d->step8 + 128;
						c = 0;

						for (j = d->payload; j > 0; j--) {
							for (k = 8; k > 0; k--) {
						    		c >>= 1;
								c |= (raw[i >> 8] >= tr) << 7;
			    					i += d->step8;
							}

							*buf++ = c;
				    		}

			    			return TRUE;
					}
				}
			}

			b1 = b;
			t += raw[1];
			t -= raw[0];
		}
	}

	return FALSE;
}
